<!-- /********************************************************************************
* Copyright (c) 2020 Contributors to the Eclipse Foundation
*
* See the NOTICE file(s) distributed with this work for additional
* information regarding copyright ownership.
*
* This program and the accompanying materials are made available under the
* terms of the Eclipse Public License v. 2.0 which is available at
* http://www.eclipse.org/legal/epl-2.0.
*
* SPDX-License-Identifier: EPL-2.0
********************************************************************************/ -->
<app-card-layout>
  <div header>
    <span>{{ 'ContactPerson.Title' | translate }}</span>
  </div>
  <div body>
    <form [ngrxFormState]="contactPersonDetailSandbox.formState$ | async">
      <div>
        <!-- firstname -->
        <div class="form-group row">
          <label for="contactPersonFirstName" class="col-sm-2 col-form-label">{{ 'ContactPerson.FirstName' | translate }}</label>
          <div class="col-sm-4">
            <input
              type="text"
              maxlength="30"
              class="form-control"
              id="contactPersonFirstName"
              [ngrxFormControlState]="((contactPersonDetailSandbox.formState$ | async)?.controls)['firstName']"
              autocomplete="off"
            />
          </div>
        </div>

        <!-- lastname -->
        <div class="form-group row">
          <label for="contactPersonLastName" class="col-sm-2 col-form-label">{{ 'ContactPerson.LastName' | translate }}</label>
          <div class="col-sm-4">
            <input
              type="text"
              required
              maxlength="255"
              class="form-control"
              id="contactPersonLastName"
              [ngrxFormControlState]="((contactPersonDetailSandbox.formState$ | async)?.controls)['lastName']"
              autocomplete="off"
            />
          </div>
        </div>

        <!-- salutation -->
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">{{ 'ContactPerson.Salutation' | translate }}</label>
          <div class="col-sm-4">
            <select type="text" class="form-control" [ngrxFormControlState]="((contactPersonDetailSandbox.formState$ | async)?.controls)['salutationId']">
              <option [value]="" selected>{{ 'SelectOption' | translate }}</option>
              <option *ngFor="let salutation of salutationSandbox.salutations$ | async" [value]="salutation.id">{{ salutation.type }}</option>
            </select>
          </div>
        </div>

        <!-- title -->
        <div class="form-group row">
          <label for="contactPersonTitle" class="col-sm-2 col-form-label">{{ 'ContactPerson.PersonTitle' | translate }}</label>
          <div class="col-sm-4">
            <input
              type="text"
              maxlength="255"
              class="form-control"
              id="contactPersonTitle"
              [ngrxFormControlState]="((contactPersonDetailSandbox.formState$ | async)?.controls)['title']"
              autocomplete="off"
            />
          </div>
        </div>

        <!-- personType -->
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">{{ 'ContactPerson.PersonType' | translate }}</label>
          <div class="col-sm-4">
            <select
              required
              type="text"
              class="form-control"
              [ngrxFormControlState]="((contactPersonDetailSandbox.formState$ | async)?.controls)['personTypeId']"
            >
              <option [value]="null">{{ 'SelectOption' | translate }}</option>
              <option *ngFor="let personType of personTypesSandbox.personTypes$ | async" [value]="personType.id">{{ personType.type }}</option>
            </select>
          </div>
        </div>

        <!-- note -->
        <div class="form-group row">
          <label for="contactPersonNote" class="col-sm-2 col-form-label">{{ 'ContactPerson.Note' | translate }}</label>
          <div class="col-sm-4">
            <input
              type="text"
              maxlength="255"
              class="form-control"
              id="contactPersonNote"
              [ngrxFormControlState]="((contactPersonDetailSandbox.formState$ | async)?.controls)['contactNote']"
              autocomplete="off"
            />
          </div>
        </div>

        <!-- buttons -->
        <div class="buttons-area">
          <div>
            <button *visibleByRight type="button" class="btn btn-success person-buttons" (click)="contactPersonDetailSandbox.saveContactPersonDetails()">
              {{ 'SaveBtn' | translate }}
            </button>

            <button type="button" class="btn btn-primary person-buttons" (click)="contactPersonDetailSandbox.navigateBackToCompany()">
              {{ 'ContactPerson.CompanyBtn' | translate }}
            </button>

            <button type="button" class="btn btn-primary person-buttons" routerLink="/overview">
              {{ 'ContactPerson.ContactOverviewBtn' | translate }}
            </button>
          </div>
          <div class="person-buttons" *ngIf="contactPersonDetailSandbox.contactPersonContactId">
            <app-anonymizer [contactId]="contactPersonDetailSandbox.contactPersonContactId"></app-anonymizer>
          </div>
        </div>
      </div>
    </form>

    <app-expandable class="expandable-address" *ngIf="isExpandableVisible">
      <span header>{{ 'Contacts.AddressList' | translate }}</span>
      <div class="expandable-body-container" body>
        <div class="table-detail-view-address" *ngIf="contactPersonDetailSandbox.isAddressDataDetailViewVisible">
          <app-contact-person-address-details [createOrEditAddressData]="createOrEditAddressData"></app-contact-person-address-details>
        </div>
        <div class="table-view-address">
          <app-contact-person-address-list
            (contactPersonAddressLoaded)="loadAddressDetail($event)"
            (createNewAddress)="loadAddressDetail($event)"
          ></app-contact-person-address-list>
        </div>
      </div>
    </app-expandable>

    <app-expandable class="expandable-communication" *ngIf="isExpandableVisible">
      <span header>{{ 'Contacts.CommunicationsDataList' | translate }}</span>
      <div class="expandable-body-container" body>
        <div class="table-detail-view-communication" *ngIf="contactPersonDetailSandbox.isCommunicationsDataDetailViewVisible">
          <app-contact-person-communications-data-details
            [createOrEditCommunicationsData]="createOrEditCommunicationsData"
          ></app-contact-person-communications-data-details>
        </div>
        <div class="table-view-communication">
          <app-contact-person-communications-data-list
            (companyDetailsIdLoaded)="loadCommunicationsDataDetail($event)"
            (createNewCompany)="loadCommunicationsDataDetail($event)"
          ></app-contact-person-communications-data-list>
        </div>
      </div>
    </app-expandable>

    <app-expandable class="expandable-module-assignment" *ngIf="isExpandableVisible">
      <span header>{{ 'Contacts.ModuleAssignment' | translate }}</span>
      <div class="expandable-body-container" body>
        <div class="table-detail-view-module-assignment" *ngIf="userModuleAssignmentSandBox.isUserModuleAssignmentDataDetailViewVisible">
          <app-module-assignment-data-details
            [createOrEditUserModuleAssignmentData]="createOrEditUserModuleAssignmentData"
          ></app-module-assignment-data-details>
        </div>
        <div class="table-view-module-assignment">
          <app-module-assignment-data-list
            (userModuleAssignmentDetailsLoaded)="loadUserModuleAssignmentDataDetail($event)"
            (createNewUserModuleAssignment)="loadUserModuleAssignmentDataDetail($event)"
          ></app-module-assignment-data-list>
        </div>
      </div>
    </app-expandable>
    <!--  -->
  </div>
</app-card-layout>
